## kdepim-runtime 22.12.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)
set(PIM_VERSION "5.22.3")
set(KDEPIM_RUNTIME_VERSION_NUMBER ${PIM_VERSION})
project(kdepim-runtime VERSION ${KDEPIM_RUNTIME_VERSION_NUMBER})

############### KDEPIM-Runtime version ################
# KDEPIM_RUNTIME_VERSION
# Version scheme: "x.y.z build".
#
# x is the version number.
# y is the major release number.
# z is the minor release number.
#
# "x.y.z" follow the kdelibs version kdepim is released with.
#
# If "z" is 0, it the version is "x.y"
#
# KDEPIM_DEV_VERSION
# is empty for final versions. For development versions "build" is
# something like "pre", "", "alpha", "beta1", "beta2", "rc1", "rc2".
#
# Examples in chronological order:
#
#    3.0
#    3.0.1
#    3.1 
#    3.1 beta1
#    3.1 beta2
#    3.1 rc1
#    3.1
#    3.1.1
#    3.2 pre
#    3.2 

set(KDEPIM_DEV_VERSION )
set(RELEASE_SERVICE_VERSION "22.12.3")

# add an extra space
if(DEFINED KDEPIM_DEV_VERSION)
    set(KDEPIM_DEV_VERSION " ${KDEPIM_DEV_VERSION}")
endif()

set(KDEPIM_RUNTIME_VERSION "${KDEPIM_RUNTIME_VERSION_NUMBER}${KDEPIM_DEV_VERSION} (${RELEASE_SERVICE_VERSION})")

configure_file(kdepim-runtime-version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/kdepim-runtime-version.h @ONLY)

set(KF5_MIN_VERSION "5.99.0")

find_package(ECM ${KF5_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${kdepim-runtime_SOURCE_DIR}/cmake/ ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMSetupVersion)
include(FeatureSummary)
include(KDEGitCommitHooks)
include(KDEClangFormat)
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h *.c)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
include(ECMInstallIcons)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(GenerateExportHeader)

set(QT_REQUIRED_VERSION "5.15.2")
if (QT_MAJOR_VERSION STREQUAL "6")
    set(QT_REQUIRED_VERSION "6.4.0")
endif()

set(KDEPIMRUNTIME_LIB_VERSION "${KDEPIM_RUNTIME_VERSION_NUMBER}")
set(KDEPIMRUNTIME_LIB_SOVERSION "5")
set(AKONADI_VERSION "5.22.3")

set(IDENTITYMANAGEMENT_LIB_VERSION "5.22.3")
set(KMAILTRANSPORT_LIB_VERSION "5.22.3")
set(CALENDARUTILS_LIB_VERSION "5.22.3")
set(KIMAP_LIB_VERSION "5.22.3")
set(KMBOX_LIB_VERSION "5.22.3")
set(AKONADICALENDAR_LIB_VERSION "5.22.3")
set(KONTACTINTERFACE_LIB_VERSION "5.22.3")
set(KMIME_LIB_VERSION "5.22.3")
set(AKONADIMIME_LIB_VERSION "5.22.3")
set(AKONADICONTACT_LIB_VERSION "5.22.3")
set(AKONADINOTE_LIB_VERSION "5.22.3")
set(KGAPI_LIB_VERSION "5.22.3")
set(LIBKDEPIM_LIB_VERSION "5.22.3")
set(KLDAP_LIB_VERSION "5.22.3")

set( SharedMimeInfo_MINIMUM_VERSION "1.3" )
find_package(SharedMimeInfo ${SharedMimeInfo_MINIMUM_VERSION} REQUIRED)

find_package(Sasl2)
set_package_properties(Sasl2 PROPERTIES TYPE REQUIRED)

find_package(Qca-qt${QT_MAJOR_VERSION} 2.2.0 CONFIG REQUIRED)
set_package_properties(Qca-qt${QT_MAJOR_VERSION} PROPERTIES DESCRIPTION "Qt Cryptographic Architecture"
                   URL "https://invent.kde.org/libraries/qca" TYPE REQUIRED
                   PURPOSE "Needed for ews resource.")
option(KDEPIM_RUN_AKONADI_TEST "Enable autotest based on Akonadi." TRUE)
# QT5 package
find_package(Qt${QT_MAJOR_VERSION}TextToSpeech ${QT_REQUIRED_VERSION} CONFIG)
set_package_properties(Qt${QT_MAJOR_VERSION}TextToSpeech PROPERTIES DESCRIPTION
    "Add support for texttospeed"
    TYPE OPTIONAL
)
if(Qt${QT_MAJOR_VERSION}TextToSpeech_FOUND)
set(HAVE_TEXT_TO_SPEECH_SUPPORT TRUE)
endif()
find_package(Qt${QT_MAJOR_VERSION} ${QT_REQUIRED_VERSION} CONFIG REQUIRED Network Widgets Test DBus NetworkAuth)
if (QT_MAJOR_VERSION STREQUAL "5" AND BUILD_TESTING)
    find_package(Qt5 ${QT_REQUIRED_VERSION} CONFIG REQUIRED XmlPatterns)
endif()
find_package(Qt${QT_MAJOR_VERSION}WebEngineWidgets ${QT_REQUIRED_VERSION} CONFIG)

# KF5 package
find_package(KF5Config ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5ConfigWidgets ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5NotifyConfig ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5KIO ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5ItemModels ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Codecs ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5WindowSystem ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5TextWidgets ${KF5_MIN_VERSION} CONFIG REQUIRED) # for KPluralHandlingSpinBox
find_package(KF5Notifications ${KF5_MIN_VERSION} CONFIG REQUIRED) # pop3, ews
find_package(KF5Holidays ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5KCMUtils ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5DAV ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5DocTools ${KF5_MIN_VERSION})
set_package_properties(KF5DocTools PROPERTIES DESCRIPTION
    "Tools to generate documentation"
    TYPE OPTIONAL
)



# KdepimLibs package
find_package(KF5Akonadi ${AKONADI_VERSION} CONFIG REQUIRED)
find_package(KF5Mime ${KMIME_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5AkonadiMime ${AKONADIMIME_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5MailTransportAkonadi ${KMAILTRANSPORT_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5IdentityManagement ${IDENTITYMANAGEMENT_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5AkonadiContact ${AKONADICONTACT_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Contacts ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5CalendarCore ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5CalendarUtils ${CALENDARUTILS_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Mbox ${KMBOX_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5IMAP ${KIMAP_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5AkonadiNotes ${AKONADINOTE_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5AkonadiCalendar ${AKONADICALENDAR_LIB_VERSION} CONFIG REQUIRED)
find_package(KPimGAPI ${KGAPI_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Libkdepim ${LIBKDEPIM_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Ldap ${KLDAP_LIB_VERSION} CONFIG REQUIRED)

#it will replace kwallet support
find_package(Qt${QT_MAJOR_VERSION}Keychain CONFIG)
set_package_properties(Qt${QT_MAJOR_VERSION}Keychain PROPERTIES
                                   DESCRIPTION "Provides support for secure credentials storage"
                                   URL "https://github.com/frankosterfeld/qtkeychain"
                                   TYPE REQUIRED)


option(KDEPIM_RUN_ISOLATED_TESTS "Run the isolated tests." FALSE)
ecm_set_disabled_deprecation_versions(QT 5.15.2 KF 5.99.0)


option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(kdepim-keychain_lib qt${QT_MAJOR_VERSION}keychain)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if (USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
    add_definitions(-DCOMPILE_WITH_UNITY_CMAKE_SUPPORT)
endif()


add_subdirectory(resources)
add_subdirectory(agents)
add_subdirectory(defaultsetup)
add_subdirectory(kioworker)
add_subdirectory(migration)
add_subdirectory(kcms)

## install the MIME type spec file for KDEPIM specific MIME types
install(FILES kdepim-mime.xml DESTINATION ${KDE_INSTALL_MIMEDIR})
update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})
ecm_qt_install_logging_categories(
        EXPORT KDEPIMRUNTIME
        FILE kdepim-runtime.categories
        DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
        )

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
ki18n_install(po)
if(KF5DocTools_FOUND)
    kdoctools_install(po)
    add_subdirectory(doc)
endif()

feature_summary(WHAT ALL
                INCLUDE_QUIET_PACKAGES
                FATAL_ON_MISSING_REQUIRED_PACKAGES
)

=== resources/CMakeLists.txt ===
# Libkolabxml
find_package(Libkolabxml 1.1 QUIET CONFIG)
set_package_properties(Libkolabxml PROPERTIES DESCRIPTION "Kolabxml" URL "http://mirror.kolabsys.com/pub/releases" TYPE OPTIONAL PURPOSE "The Kolab XML Format Schema Definitions Library is required to build the Kolab Groupware Resource")

# Etebase library
find_package(Etebase CONFIG)
set_package_properties(Etebase PROPERTIES URL "https://github.com/etesync/libetebase/releases" TYPE OPTIONAL PURPOSE "The Etebase library is required to build the EteSync Groupware Resource")

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/shared/singlefileresource/
  ${CMAKE_CURRENT_BINARY_DIR}/shared/singlefileresource/
  ${CMAKE_CURRENT_SOURCE_DIR}/folderarchivesettings/
)


# resource tests
macro( akonadi_add_resourcetest _testname _script )
  if ( ${EXECUTABLE_OUTPUT_PATH} )
    set( _exepath ${EXECUTABLE_OUTPUT_PATH} )
  else ()
    set( _exepath ${kdepim-runtime_BINARY_DIR}/resourcetester )
  endif ()
  if (WIN32)
    set(_resourcetester ${_exepath}/resourcetester.bat)
  else ()
    set(_resourcetester ${_exepath}/resourcetester)
  endif ()
  if (UNIX)
    set(_resourcetester ${_resourcetester}.shell)
  endif ()
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${_script} ${CMAKE_CURRENT_BINARY_DIR}/${_script} COPYONLY)
  if (KDEPIM_RUN_ISOLATED_TESTS)
    add_test( NAME akonadi-mysql-db-${_testname} COMMAND akonaditest -c ${kdepim-runtime_SOURCE_DIR}/resourcetester/tests/unittestenv/config-mysql-db.xml ${_resourcetester} -c ${CMAKE_CURRENT_BINARY_DIR}/${_script} )
  endif ()
endmacro( akonadi_add_resourcetest )



add_subdirectory( akonotes )
add_subdirectory( contacts )
add_subdirectory( dav )
add_subdirectory( ical )
add_subdirectory( imap )
if (Libkolabxml_FOUND)
    # The boost-provided CMake files are unreliable
    set(Boost_NO_BOOST_CMAKE ON)
    find_package(Boost MODULE REQUIRED COMPONENTS atomic thread system)
    unset(Boost_NO_BOOST_CMAKE)
    add_subdirectory( kolab )
endif()

if (Etebase_FOUND)
    add_subdirectory( etesync )
endif()

#Disable it as it seems Facebook disabled the login and event API has been crippled
#add_subdirectory( facebook )
add_subdirectory( maildir )

add_subdirectory( openxchange )
add_subdirectory( pop3 )

add_subdirectory( google-groupware )

add_subdirectory( shared )
add_subdirectory( birthdays )
add_subdirectory( mixedmaildir )
add_subdirectory( mbox )
add_subdirectory( vcarddir )
add_subdirectory( icaldir )
add_subdirectory( vcard )
add_subdirectory( folderarchivesettings )
if (TARGET Qt::WebEngineWidgets)
    add_subdirectory( tomboynotes )
    add_subdirectory( ews )
endif()

=== agents/newmailnotifier/CMakeLists.txt ===

include_directories(${kdepim-runtime_BINARY_DIR})
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_newmailnotifier_agent\")
configure_file(config-newmailnotifier.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-newmailnotifier.h)

add_executable( akonadi_newmailnotifier_agent)
set(newmailnotifier_common_SRCS)
kconfig_add_kcfg_files(newmailnotifier_common_SRCS
    newmailnotifieragentsettings.kcfgc
  )

ecm_qt_declare_logging_category(newmailnotifier_common_SRCS HEADER newmailnotifier_debug.h IDENTIFIER NEWMAILNOTIFIER_LOG CATEGORY_NAME org.kde.pim.newmailnotifier
        DESCRIPTION "mailnotifier agent (kdepim-runtime)"
        OLD_CATEGORY_NAMES log_newmailnotifier
        EXPORT KDEPIMRUNTIME
    )



qt_add_dbus_adaptor(newmailnotifieragent_SRCS org.freedesktop.Akonadi.NewMailNotifier.xml newmailnotifieragent.h NewMailNotifierAgent)
target_sources(akonadi_newmailnotifier_agent PRIVATE
  newmailnotifieragent.cpp
  specialnotifierjob.cpp
  newmailnotifiershowmessagejob.cpp
  newmailnotifierreplymessagejob.cpp
  newmailnotifieragent.h
  specialnotifierjob.h
  newmailnotifiershowmessagejob.h
  newmailnotifierreplymessagejob.h
  ${newmailnotifier_common_SRCS}
  ${newmailnotifieragent_SRCS}
)

if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_newmailnotifier_agent PROPERTIES UNITY_BUILD ON)
endif()

target_link_libraries( akonadi_newmailnotifier_agent
  KF5::AkonadiCore
  KF5::Mime
  KF5::AkonadiMime
  KF5::AkonadiContact
  KF5::Codecs
  KF5::IdentityManagement
  KF5::AkonadiAgentBase
  KF5::Notifications
  KF5::Service
  KF5::I18n
  KF5::KIOGui
)

if(Qt${QT_MAJOR_VERSION}TextToSpeech_FOUND)
    target_link_libraries( akonadi_newmailnotifier_agent
      Qt::TextToSpeech
    )
endif()

if( APPLE )
  set_target_properties( akonadi_newmailnotifier_agent PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/Info.plist.template)
  set_target_properties( akonadi_newmailnotifier_agent PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.newmailnotifier")
  set_target_properties( akonadi_newmailnotifier_agent PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE New Mail Notifier")
endif ()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()
install(TARGETS akonadi_newmailnotifier_agent ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )


install(FILES newmailnotifieragent.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents")
install(FILES akonadi_newmailnotifier_agent.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR} )

########################## Config plugin #################################

kcoreaddons_add_plugin(newmailnotifierconfig
    INSTALL_NAMESPACE "pim${QT_MAJOR_VERSION}/akonadi/config")

target_sources(newmailnotifierconfig PRIVATE
    newmailnotifiersettingswidget.cpp
    newmailnotifierselectcollectionwidget.cpp
    newmailnotifiersettingswidget.h
    newmailnotifierselectcollectionwidget.h
    ${newmailnotifier_common_SRCS}
    )

target_link_libraries(newmailnotifierconfig
    KF5::AkonadiCore
    KF5::AkonadiMime
    Qt::Widgets
    KF5::NotifyConfig
    KF5::ConfigGui
    KF5::I18n
    KF5::XmlGui
    KF5::Mime
    KF5::Completion
)

=== kioworker/akonadi/CMakeLists.txt ===


add_library(kio_akonadi MODULE akonadiworker.cpp akonadiworker.h)

ecm_qt_declare_logging_category(kio_akonadi HEADER akonadiworker_debug.h IDENTIFIER AKONADIWORKER_LOG CATEGORY_NAME org.kde.pim.akonadiworker
    DESCRIPTION "kioworker (akonadi)"
    OLD_CATEGORY_NAMES log_akonadislave org.kde.pim.akonadislave
    EXPORT KDEPIMRUNTIME
    )


target_link_libraries(kio_akonadi  
                      KF5::KIOCore 
                      KF5::AkonadiCore 
                      KF5::I18n
                      Qt::DBus
                      Qt::Widgets
                      Qt::Network
                      )
set_target_properties(kio_akonadi PROPERTIES OUTPUT_NAME "akonadi")

install(TARGETS kio_akonadi DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio )

=== resources/akonotes/CMakeLists.txt ===
include_directories(
    ${kdepim-runtime_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../maildir
    ${CMAKE_CURRENT_BINARY_DIR}/../maildir
    ${CMAKE_CURRENT_SOURCE_DIR}/../maildir/libmaildir
)


add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_akonotes_resource\")

set(akonotes_common_SRCS)
kconfig_add_kcfg_files(akonotes_common_SRCS ../maildir/settings.kcfgc)

################################# Resource #################################

set( akonotesresource_SRCS
  ../maildir/maildirresource.cpp
  ../maildir/retrieveitemsjob.cpp
  ../maildir/maildirresource_debug.cpp
  akonotesresource.cpp
  ../maildir/maildirresource.h
  ../maildir/retrieveitemsjob.h
  ../maildir/maildirresource_debug.h
  akonotesresource.h
  ${akonotes_common_SRCS}
)

kcfg_generate_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/../maildir/maildirresource.kcfg org.kde.Akonadi.Maildir.Settings)

qt_add_dbus_adaptor(akonotesresource_SRCS
  ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.Maildir.Settings.xml settings.h Akonadi_Maildir_Resource::MaildirSettings maildirsettingsadaptor MaildirSettingsAdaptor
)

install( FILES akonotesresource.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents" )

add_executable(akonadi_akonotes_resource ${akonotesresource_SRCS})
if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_akonotes_resource PROPERTIES UNITY_BUILD ON)
endif()

target_link_libraries(akonadi_akonotes_resource
    KF5::AkonadiCore
    KF5::AkonadiMime
    KF5::Mime
    KF5::AkonadiAgentBase
    KF5::I18n
    maildir
    folderarchivesettings
)

install(TARGETS akonadi_akonotes_resource ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

############################### Config plugin #################################


kcoreaddons_add_plugin(akonotesconfig
    INSTALL_NAMESPACE pim${QT_MAJOR_VERSION}/akonadi/config
)

ki18n_wrap_ui(akonotesconfig ../maildir/settings.ui)
target_sources(akonotesconfig PRIVATE
    ../maildir/configwidget.cpp
    ../maildir/maildirconfig.cpp
    akonotesconfig.cpp
    ../maildir/configwidget.h
    ../maildir/maildirconfig.h
    ${akonotes_common_SRCS}
)
if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonotesconfig PROPERTIES UNITY_BUILD ON)
endif()

target_link_libraries(akonotesconfig
    KF5::AkonadiCore
    KF5::KIOWidgets
    KF5::ConfigWidgets
    KF5::I18n
    maildir
    folderarchivesettings
)

=== resources/facebook/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_facebook_resource\")
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

add_library(facebookresourcelib STATIC)
ecm_qt_declare_logging_category(facebookresourcelib HEADER resource_debug.h IDENTIFIER FBRESOURCE_LOG CATEGORY_NAME org.kde.pim.fbresource)

set(fbresource_common_SRCS)
kconfig_add_kcfg_files(fbresource_common_SRCS settings.kcfgc)
kcfg_generate_dbus_interface(settings.kcfg org.kde.Akonadi.Facebook.Settings )

target_sources(facebookresourcelib PRIVATE
    listjob.cpp
    eventslistjob.cpp
    birthdaylistjob.cpp
    tokenjobs.cpp
    graph.cpp
    ${fbresource_common_SRCS}
)


target_link_libraries(facebookresourcelib
    KF5::KIOWidgets
    KF5::I18n
    KF5::ConfigGui
    KF5::CalendarCore
    Qt::WebEngineWidgets
    KF5::Wallet
    KF5::Codecs
)

#####

add_executable(akonadi_facebook_resource resource.cpp)
target_link_libraries(akonadi_facebook_resource
    facebookresourcelib
    KF5::AkonadiAgentBase
    KF5::CalendarCore
    KF5::I18n
    KF5::Wallet
    KF5::Codecs
    Qt::WebEngineWidgets
    KF5::KIOCore
)

install(TARGETS akonadi_facebook_resource ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(
  FILES facebookresource.desktop
  DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents"
)

############################### Config plugin ################################
set(facebookconfig_ui_SRCS)
ki18n_wrap_ui(facebookconfig_ui_SRCS facebookagentsettingswidget.ui)

set(facebookconfig_SRCS
    facebooksettingswidget.cpp
    ${facebookconfig_ui_SRCS}
    ${fbresource_common_SRCS}
    )


kcoreaddons_add_plugin(facebookconfig
    SOURCES ${facebookconfig_SRCS}
    INSTALL_NAMESPACE "pim${QT_MAJOR_VERSION}/akonadi/config"
    )
target_link_libraries(facebookconfig
    facebookresourcelib
    KF5::AkonadiCore
    KF5::CalendarCore
    KF5::Codecs
    KF5::AkonadiAgentBase
    KF5::Contacts
    KF5::AkonadiWidgets
    KF5::I18n
    KF5::KIOWidgets
    )

=== resources/ical/CMakeLists.txt ===
include_directories(
    ${kdepim-runtime_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/shared
)

add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_ical_resource\")

add_subdirectory( wizard )
add_subdirectory( notes )

if(BUILD_TESTING)
    add_subdirectory( autotests )
endif()

set(icalresource_common_SRCS)
kconfig_add_kcfg_files(icalresource_common_SRCS settings.kcfgc)

############################# Resource #################################
add_definitions( -DSETTINGS_NAMESPACE=Akonadi_ICal_Resource )
add_executable(akonadi_ical_resource)



kcfg_generate_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/icalresource.kcfg org.kde.Akonadi.ICal.Settings)
qt_add_dbus_adaptor(icalresource_SRCS
  ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.ICal.Settings.xml settings.h Akonadi_ICal_Resource::Settings icalsettingsadaptor ICalSettingsAdaptor
)

if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_ical_resource PROPERTIES UNITY_BUILD ON)
endif()
target_sources( akonadi_ical_resource PRIVATE
  icalresource.cpp
  shared/icalresourcebase.cpp
  shared/icalresource.cpp
  shared/icalresourcebase.h
  shared/icalresource.h
  ${icalresource_common_SRCS}
  ${icalresource_SRCS}
)

if( APPLE )
  set_target_properties(akonadi_ical_resource PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/../Info.plist.template)
  set_target_properties(akonadi_ical_resource PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.ICal")
  set_target_properties(akonadi_ical_resource PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi iCal Resource")
endif ()

install( FILES icalresource.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents" )
target_link_libraries(akonadi_ical_resource KF5::AkonadiCore   KF5::KIOCore KF5::CalendarCore KF5::AkonadiAgentBase akonadi-singlefileresource)
if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_ical_resource PROPERTIES UNITY_BUILD ON)
endif()
install(TARGETS akonadi_ical_resource ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

################################ Config plugin ###############################

kcoreaddons_add_plugin(icalconfig
    INSTALL_NAMESPACE "pim${QT_MAJOR_VERSION}/akonadi/config"
)
target_sources(icalconfig PRIVATE icalconfig.cpp ${icalresource_common_SRCS})
target_link_libraries(icalconfig
    KF5::AkonadiCore
    akonadi-singlefileresource
)

=== resources/imap/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_imap_resource\")

set(WITH_GMAIL_XOAUTH2 TRUE)

configure_file(config-imap.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-imap.h)

########### next target ###############

set( imapresource_LIB_SRCS
  addcollectiontask.cpp
  additemtask.cpp
  batchfetcher.cpp
  changecollectiontask.cpp
  changeitemsflagstask.cpp
  changeitemtask.cpp
  expungecollectiontask.cpp
  highestmodseqattribute.cpp
  imapaccount.cpp
  imapflags.cpp
  imapresourcebase.cpp
  messagehelper.cpp
  movecollectiontask.cpp
  moveitemstask.cpp
  noselectattribute.cpp
  noinferiorsattribute.cpp
  passwordrequesterinterface.cpp
  removecollectionrecursivetask.cpp
  resourcestateinterface.cpp
  resourcetask.cpp
  retrievecollectionmetadatatask.cpp
  retrievecollectionstask.cpp
  retrieveitemtask.cpp
  retrieveitemstask.cpp
  searchtask.cpp
  sessionpool.cpp
  uidvalidityattribute.cpp
  uidnextattribute.cpp
  settings.cpp
  subscriptiondialog.cpp
  imapidlemanager.cpp
  resourcestate.cpp
  collectionmetadatahelper.cpp
  replacemessagejob.cpp

  addcollectiontask.h
  additemtask.h
  batchfetcher.h
  changecollectiontask.h
  changeitemsflagstask.h
  changeitemtask.h
  expungecollectiontask.h
  highestmodseqattribute.h
  imapaccount.h
  imapflags.h
  imapresourcebase.h
  messagehelper.h
  movecollectiontask.h
  moveitemstask.h
  noselectattribute.h
  noinferiorsattribute.h
  passwordrequesterinterface.h
  removecollectionrecursivetask.h
  resourcestateinterface.h
  resourcetask.h
  retrievecollectionmetadatatask.h
  retrievecollectionstask.h
  retrieveitemtask.h
  retrieveitemstask.h
  searchtask.h
  sessionpool.h
  uidvalidityattribute.h
  uidnextattribute.h
  settings.h
  subscriptiondialog.h
  imapidlemanager.h
  resourcestate.h
  collectionmetadatahelper.h
  replacemessagejob.h
  ${AKONADI_COLLECTIONATTRIBUTES_SHARED_SOURCES}
  ${AKONADI_IMAPATTRIBUTES_SHARED_SOURCES}
)

ecm_qt_declare_logging_category(imapresource_LIB_SRCS HEADER imapresource_debug.h IDENTIFIER IMAPRESOURCE_LOG CATEGORY_NAME org.kde.pim.imapresource
        DESCRIPTION "imap resource (kdepim-runtime)"
        OLD_CATEGORY_NAMES log_imapresource
        EXPORT KDEPIMRUNTIME
    )
ecm_qt_declare_logging_category(imapresource_LIB_SRCS HEADER imapresource_trace.h
        IDENTIFIER IMAPRESOURCE_TRACE
        CATEGORY_NAME org.kde.pim.imapresource.trace
        DESCRIPTION "resource kolab trace (kdepim-runtime)"
        EXPORT KDEPIMRUNTIME
        )

kcfg_generate_dbus_interface( ${CMAKE_CURRENT_SOURCE_DIR}/imapresource.kcfg org.kde.Akonadi.Imap.Settings )
kconfig_add_kcfg_files(imapresource_LIB_SRCS settingsbase.kcfgc)

qt_add_dbus_adaptor( imapresource_LIB_SRCS
     ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.Imap.Settings.xml settings.h Settings
     )

qt_generate_dbus_interface( ${CMAKE_CURRENT_SOURCE_DIR}/imapresourcebase.h org.kde.Akonadi.Imap.Resource.xml OPTIONS -a )
qt_add_dbus_adaptor( imapresource_LIB_SRCS
     ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.Imap.Resource.xml
        imapresourcebase.h ImapResourceBase
     )

add_library(imapresource STATIC ${imapresource_LIB_SRCS})

target_link_libraries(imapresource
    Qt::DBus
    Qt::Network
    KF5::AkonadiCore
    KF5::IMAP
    KF5::MailTransport
    KF5::KIOWidgets
    KF5::Mime
    KF5::AkonadiMime
    KF5::IdentityManagementWidgets
    KF5::AkonadiAgentBase
    KF5::I18n
    KF5::WindowSystem
    KF5::ConfigGui
    akonadi-singlefileresource
    KF5::Libkdepim
    ${kdepim-keychain_lib}
)

########### next target ###############

add_executable(akonadi_imap_resource)
ki18n_wrap_ui(akonadi_imap_resource setupserverview_desktop.ui)
target_sources( akonadi_imap_resource PRIVATE
  main.cpp
  imapresource.cpp
  resourcestate.cpp
  settingspasswordrequester.cpp
  setupserver.cpp
  serverinfodialog.cpp
  passwordrequester.cpp
  gmailpasswordrequester.cpp

  imapresource.h
  resourcestate.h
  settingspasswordrequester.h
  setupserver.h
  serverinfodialog.h
  passwordrequester.h
  gmailpasswordrequester.h
  )

install( FILES imapresource.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents" )



if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_imap_resource PROPERTIES UNITY_BUILD ON)
endif()
if( APPLE )
  set_target_properties(akonadi_imap_resource PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/../Info.plist.template)
  set_target_properties(akonadi_imap_resource PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.Imap")
  set_target_properties(akonadi_imap_resource PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi IMAP Resource")
endif ()

target_link_libraries(akonadi_imap_resource
    Qt::DBus
    KF5::AkonadiCore
    KF5::IMAP
    akonadi-singlefileresource
    KF5::AkonadiWidgets
    KF5::MailTransport
    KF5::Mime
    KF5::AkonadiMime
    KF5::IdentityManagement
    KF5::I18n
    imapresource
    KF5::TextWidgets
    KF5::ConfigGui

    folderarchivesettings
    KPim::GAPICore
)

install(
    FILES org.kde.akonadi_imap_resource.desktop
    DESTINATION ${KDE_INSTALL_APPDIR}
)

install(TARGETS akonadi_imap_resource ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

add_subdirectory( wizard )

if(BUILD_TESTING)
    add_subdirectory( autotests )
    add_subdirectory( tests )
endif()

=== resources/kolab/CMakeLists.txt ===
add_subdirectory(pimkolab)
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/../imap
    ${CMAKE_CURRENT_BINARY_DIR}/../imap
    ${CMAKE_CURRENT_SOURCE_DIR}/pimkolab/
    ${Libkolabxml_INCLUDES}
    )

add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_imap_resource\")


########### next target ###############

set(kolabresource_SRCS
    ../imap/settingspasswordrequester.cpp
    ../imap/setupserver.cpp
    ../imap/serverinfodialog.cpp
    kolabretrievecollectionstask.cpp
    kolabresource.cpp
    kolabresourcestate.cpp
    kolabhelpers.cpp
    kolabmessagehelper.cpp
    kolabaddtagtask.cpp
    kolabchangetagtask.cpp
    kolabremovetagtask.cpp
    kolabretrievetagstask.cpp
    kolabsettings.cpp
    tagchangehelper.cpp
    kolabrelationresourcetask.cpp
    kolabchangeitemsrelationstask.cpp
    kolabchangeitemstagstask.cpp
    updatemessagejob.cpp
    ../imap/settingspasswordrequester.h
    ../imap/setupserver.h
    ../imap/serverinfodialog.h
    kolabretrievecollectionstask.h
    kolabresource.h
    kolabresourcestate.h
    kolabhelpers.h
    kolabmessagehelper.h
    kolabaddtagtask.h
    kolabchangetagtask.h
    kolabremovetagtask.h
    kolabretrievetagstask.h
    kolabsettings.h
    tagchangehelper.h
    kolabrelationresourcetask.h
    kolabchangeitemsrelationstask.h
    kolabchangeitemstagstask.h
    updatemessagejob.h
    )

ecm_qt_declare_logging_category(kolabresource_SRCS
    HEADER kolabresource_debug.h
    IDENTIFIER KOLABRESOURCE_LOG
    CATEGORY_NAME org.kde.pim.kolabresource
    DESCRIPTION "kolab resource (kdepim-runtime)"
    OLD_CATEGORY_NAMES log_kolabresource
    EXPORT KDEPIMRUNTIME
    )
ecm_qt_declare_logging_category(kolabresource_SRCS
    HEADER kolabresource_trace.h
    IDENTIFIER KOLABRESOURCE_TRACE
    CATEGORY_NAME org.kde.pim.kolabresource.trace
    DESCRIPTION "resource kolab trace (kdepim-runtime)"
    EXPORT KDEPIMRUNTIME
    )


kconfig_add_kcfg_files(kolabresource_SRCS ../imap/settingsbase.kcfgc)

ki18n_wrap_ui(kolabresource_SRCS ../imap/setupserverview_desktop.ui)
add_executable(akonadi_kolab_resource ${kolabresource_SRCS})

target_link_libraries(akonadi_kolab_resource
    KF5::AkonadiCore
    KF5::IMAP
    KF5::MailTransport
    KF5::Mime
    KF5::AkonadiMime
    KF5::AkonadiCalendar
    KF5::AkonadiWidgets
    KF5::IdentityManagement
    imapresource
    folderarchivesettings
    pimkolab
    KF5::Contacts
    KF5::CalendarCore
    akonadi-singlefileresource
    KF5::TextWidgets
    KF5::I18n
    )

install(FILES kolabresource.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents")
install(TARGETS akonadi_kolab_resource ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install( FILES org.kde.akonadi_kolab_resource.desktop DESTINATION ${KDE_INSTALL_APPDIR} )

if (BUILD_TESTING)
    #add_subdirectory(autotests)
endif()
add_subdirectory(wizard)

=== resources/mbox/CMakeLists.txt ===

add_subdirectory(wizard)

set(mboxresource_common_SRCS
    deleteditemsattribute.cpp
    deleteditemsattribute.h
    )
kconfig_add_kcfg_files(mboxresource_common_SRCS settings.kcfgc)

################################## Resource #################################
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_mbox_resource\")

set( mboxresource_SRCS
    mboxresource.cpp
    mboxresource.h
    ${mboxresource_common_SRCS}
    )

# mboxresource.cpp needs UI files generated for another target. We must be sure the files
# were created before building the akonadi_mbox_resource target.
add_custom_target(generated_headers
    DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/ui_compactpage.h
    ${CMAKE_CURRENT_BINARY_DIR}/ui_lockfilepage.h
    )
set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/ui_compactpage.h
    ${CMAKE_CURRENT_BINARY_DIR}/ui_lockfilepage.h
    PROPERTIES GENERATED TRUE
    )

ecm_qt_declare_logging_category(mboxresource_SRCS HEADER mboxresource_debug.h IDENTIFIER MBOXRESOURCE_LOG CATEGORY_NAME org.kde.pim.mboxresource
    DESCRIPTION "mbox resource (kdepim-runtime)"
    OLD_CATEGORY_NAMES log_mboxresource
    EXPORT KDEPIMRUNTIME
    )


install( FILES mboxresource.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents" )

kcfg_generate_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/mboxresource.kcfg org.kde.Akonadi.Mbox.Settings)
qt_add_dbus_adaptor(mboxresource_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.Mbox.Settings.xml settings.h Settings
    )

add_executable(akonadi_mbox_resource ${mboxresource_SRCS})
if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_mbox_resource PROPERTIES UNITY_BUILD ON)
endif()
add_dependencies(akonadi_mbox_resource generated_headers)

if( APPLE )
    set_target_properties(akonadi_mbox_resource PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/../Info.plist.template)
    set_target_properties(akonadi_mbox_resource PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.Mbox")
    set_target_properties(akonadi_mbox_resource PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi Mbox Resource")
endif ()

target_link_libraries(akonadi_mbox_resource
    KF5::I18n
    KF5::Mbox
    KF5::AkonadiCore
    KF5::AkonadiMime
    KF5::KIOCore
    KF5::Mime
    KF5::AkonadiAgentBase
    KF5::Completion
    akonadi-singlefileresource
    )

install(TARGETS akonadi_mbox_resource ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()

############################# Config plugin ################################
kcoreaddons_add_plugin(mboxconfig
    INSTALL_NAMESPACE "pim${QT_MAJOR_VERSION}/akonadi/config"
    )

target_sources(mboxconfig PRIVATE
    mboxconfig.cpp
    lockmethodpage.cpp
    compactpage.cpp
    lockmethodpage.h
    compactpage.h
    ${mboxresource_common_SRCS}
    )

ki18n_wrap_ui(mboxconfig
    compactpage.ui
    lockfilepage.ui
    )

target_link_libraries(mboxconfig
    KF5::AkonadiCore
    KF5::ConfigWidgets
    KF5::KIOWidgets
    KF5::I18n
    KF5::Mbox
    akonadi-singlefileresource
    )

=== resources/mixedmaildir/CMakeLists.txt ===
include_directories(
    ${kdepim-runtime_SOURCE_DIR}
    ${kdepim-runtime_SOURCE_DIR}/resources/shared
    ${kdepim-runtime_SOURCE_DIR}/resources/shared/filestore
    ${kdepim-runtime_SOURCE_DIR}/resources/maildir
    ${kdepim-runtime_SOURCE_DIR}/resources/mbox
    ${CMAKE_CURRENT_SOURCE_DIR}/kmindexreader
    )

add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_mixedmaildir_resource\")

add_subdirectory(kmindexreader)

set(mixedmaildir_common_SRCS)
kconfig_add_kcfg_files(mixedmaildir_common_SRCS settings.kcfgc)

############################# Resource #######################################

set( mixedmaildirresource_SRCS
    compactchangehelper.cpp
    mixedmaildirresource.cpp
    mixedmaildirstore.cpp
    retrieveitemsjob.cpp
    compactchangehelper.h
    mixedmaildirresource.h
    mixedmaildirstore.h
    retrieveitemsjob.h
    ${mixedmaildir_common_SRCS}
    )
ecm_qt_declare_logging_category(mixedmaildirresource_SRCS HEADER mixedmaildirresource_debug.h IDENTIFIER MIXEDMAILDIRRESOURCE_LOG CATEGORY_NAME org.kde.pim.mixedmaildirresource
    DESCRIPTION "mixed maildir resource (kdepim-runtime)"
    OLD_CATEGORY_NAMES log_mixedmaildir
    EXPORT KDEPIMRUNTIME
    )
ecm_qt_declare_logging_category(mixedmaildirresource_SRCS HEADER mixedmaildir_debug.h IDENTIFIER MIXEDMAILDIR_LOG CATEGORY_NAME org.kde.pim.mixedmaildir
    DESCRIPTION "mixedmaildir resource (kdepim-runtime)"
    OLD_CATEGORY_NAMES log_mixedmaildirresource
    EXPORT KDEPIMRUNTIME
    )

install( FILES mixedmaildirresource.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents" )


kcfg_generate_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/mixedmaildirresource.kcfg org.kde.Akonadi.MixedMaildir.Settings)

qt_add_dbus_adaptor(mixedmaildirresource_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.MixedMaildir.Settings.xml settings.h Settings
    )

add_executable(akonadi_mixedmaildir_resource ${mixedmaildirresource_SRCS})
if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_mixedmaildir_resource PROPERTIES UNITY_BUILD ON)
endif()
if( APPLE )
    set_target_properties(akonadi_mixedmaildir_resource PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/../Info.plist.template)
    set_target_properties(akonadi_mixedmaildir_resource PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.MixedMaildir")
    set_target_properties(akonadi_mixedmaildir_resource PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi MixedMaildir Resource")
endif ()

target_link_libraries(akonadi_mixedmaildir_resource
    kmindexreader
    maildir
    akonadi-filestore
    KF5::AkonadiCore
    KF5::AkonadiMime
    KF5::KIOCore
    KF5::Mbox
    KF5::Mime
    KF5::AkonadiAgentBase
    KF5::I18n
    akonadi-singlefileresource
    )
if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_mixedmaildir_resource PROPERTIES UNITY_BUILD ON)
endif()

install(TARGETS akonadi_mixedmaildir_resource ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.MixedMaildir.Settings.xml
    DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR})

# unit tests
if (BUILD_TESTING)
    add_subdirectory( autotests )
endif ()

###################################### Config Plugin #########################

kcoreaddons_add_plugin(mixedmaildirconfig
    INSTALL_NAMESPACE "pim${QT_MAJOR_VERSION}/akonadi/config"
    )
target_sources(mixedmaildirconfig PRIVATE
    mixedmaildirconfig.cpp
    configwidget.cpp
    configwidget.h
    ${mixedmaildir_common_SRCS}
    )
ki18n_wrap_ui(mixedmaildirconfig settings.ui)


target_link_libraries(mixedmaildirconfig
    KF5::AkonadiCore
    KF5::I18n
    KF5::KIOWidgets
    KF5::ConfigWidgets
    maildir
    )

=== resources/pop3/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_pop3_resource\")


set(pop3_common_SRCS
    settings.cpp
    )
kconfig_add_kcfg_files(pop3_common_SRCS settingsbase.kcfgc)
ecm_qt_declare_logging_category(pop3_common_SRCS HEADER pop3resource_debug.h IDENTIFIER POP3RESOURCE_LOG CATEGORY_NAME org.kde.pim.pop3resource
    DESCRIPTION "pop3 resource (kdepim-runtime)"
    OLD_CATEGORY_NAMES log_pop3resource
    EXPORT KDEPIMRUNTIME
    )
ecm_qt_declare_logging_category(pop3_common_SRCS HEADER pop3protocol_debug.h IDENTIFIER POP3_LOG CATEGORY_NAME org.kde.pim.pop3protocol
    DESCRIPTION "pop3 protocol (kdepim-runtime)"
    EXPORT KDEPIMRUNTIME
    )

kcfg_generate_dbus_interface(${CMAKE_CURRENT_SOURCE_DIR}/settings.kcfg org.kde.Akonadi.POP3.Settings)
qt_add_dbus_adaptor(pop3_common_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/org.kde.Akonadi.POP3.Settings.xml settings.h Settings
    )

################################# Resource ####################################

set( pop3resource_SRCS
    pop3resource.cpp
    pop3protocol.cpp
    jobs.cpp
    pop3resource.h
    pop3protocol.h
    jobs.h
    ${pop3_common_SRCS}
    )

install( FILES pop3resource.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents" )

#add_executable(akonadi_pop3_resource RUN_UNINSTALLED ${pop3resource_SRCS})
add_executable(akonadi_pop3_resource ${pop3resource_SRCS})
if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_pop3_resource PROPERTIES UNITY_BUILD ON)
endif()
if( APPLE )
    set_target_properties(akonadi_pop3_resource PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/../Info.plist.template)
    set_target_properties(akonadi_pop3_resource PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.POP3")
    set_target_properties(akonadi_pop3_resource PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi POP3 Resource")
endif ()


target_link_libraries( akonadi_pop3_resource
    KF5::AkonadiCore
    KF5::AkonadiMime
    KF5::Mime
    KF5::MailTransport
    KF5::AkonadiAgentBase
    KF5::I18n
    KF5::KIOWidgets  # SslUi
    KF5::Notifications
    Qt::DBus
    Qt::Network # QNetworkProxy
    ${kdepim-keychain_lib}
    KF5::WidgetsAddons
    Sasl2::Sasl2
    )
if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_pop3_resource PROPERTIES UNITY_BUILD ON)
endif()

if(BUILD_TESTING)
    add_subdirectory( autotests )
endif()

add_subdirectory( wizard )

install(TARGETS akonadi_pop3_resource ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES akonadi_pop3_resource.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})


################################## Config plugin ##############################
kcoreaddons_add_plugin(pop3config
    INSTALL_NAMESPACE "pim${QT_MAJOR_VERSION}/akonadi/config"
    )

target_sources(pop3config PRIVATE
    pop3config.cpp
    accountwidget.cpp
    accountwidget.h
    ${pop3_common_SRCS}
    )
ki18n_wrap_ui(pop3config popsettings.ui)

target_link_libraries(pop3config
    KF5::AkonadiCore
    KF5::TextWidgets
    KF5::Completion
    KF5::WidgetsAddons
    KF5::I18n
    KF5::MailTransport
    KF5::AkonadiWidgets
    KF5::AkonadiAgentBase
    KF5::AkonadiMime
    KF5::Libkdepim
    ${kdepim-keychain_lib}
    )

=== debian/changelog ===
kdepim-runtime (4:22.12.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.12.3).
  * Update build-deps and deps with the info from cmake.
  * Remove inactive uploaders, thanks for your work.

 -- Patrick Franz <deltaone@debian.org>  Wed, 01 Mar 2023 21:32:52 +0100

kdepim-runtime (4:22.12.2-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.12.2).
  * Update build-deps and deps with the info from cmake.

 -- Patrick Franz <deltaone@debian.org>  Sun, 05 Feb 2023 00:27:12 +0100

kdepim-runtime (4:22.12.0-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Wed, 04 Jan 2023 21:35:43 +0100

kdepim-runtime (4:22.12.0-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.12.0).
  * Update build-deps and deps with the info from cmake.
  * Update patches.
  * Bump Standards-Version to 4.6.2 (No changes needed).

 -- Patrick Franz <deltaone@debian.org>  Thu, 22 Dec 2022 21:05:11 +0100

kdepim-runtime (4:22.08.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.08.3).
  * Update build-deps and deps with the info from cmake.

 -- Patrick Franz <deltaone@debian.org>  Fri, 04 Nov 2022 21:55:01 +0100

kdepim-runtime (4:22.08.2-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.08.2).
  * Update build-deps and deps with the info from cmake.

 -- Patrick Franz <deltaone@debian.org>  Sat, 29 Oct 2022 00:12:23 +0200

kdepim-runtime (4:22.08.0-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Sat, 10 Sep 2022 13:09:36 +0200

kdepim-runtime (4:22.08.0-1) experimental; urgency=medium

  [ Patrick Franz ]
  * Update upstream signing-key.
  * Bump Standards-Version to 4.6.1 (No changes needed).
  * New upstream release (22.08.0).
  * Update build-deps and deps with the info from cmake.
  * Update patches.

 -- Patrick Franz <deltaone@debian.org>  Wed, 31 Aug 2022 01:46:30 +0200

kdepim-runtime (4:22.04.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.04.3).
  * Update build-deps and deps with the info from cmake.
  * Remove arch-restriction for libkpimgapi-dev B-D.

 -- Patrick Franz <deltaone@debian.org>  Thu, 14 Jul 2022 21:57:58 +0200

kdepim-runtime (4:22.04.2-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Mon, 27 Jun 2022 22:02:14 +0200

kdepim-runtime (4:22.04.2-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.04.2).
  * Update build-deps and deps with the info from cmake.

 -- Patrick Franz <deltaone@debian.org>  Sun, 19 Jun 2022 02:47:33 +0200

kdepim-runtime (4:22.04.1-2) experimental; urgency=medium

  [ Patrick Franz ]
  * Remove unused libkf5pimcommon-dev B-D.

 -- Patrick Franz <deltaone@debian.org>  Sat, 28 May 2022 00:54:40 +0200

kdepim-runtime (4:22.04.1-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.04.1).
  * Update build-deps and deps with the info from cmake.
  * Remove dependency to kalarm as it is not used anymore.
  * Remove make_qtwebengine_optional.patch as it is not needed anymore.

 -- Patrick Franz <deltaone@debian.org>  Thu, 26 May 2022 16:13:36 +0200

kdepim-runtime (4:21.12.3-4) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Fri, 01 Apr 2022 22:11:00 +0200

kdepim-runtime (4:21.12.3-3) experimental; urgency=medium

  [ Patrick Franz ]
  * Fix patches.

 -- Patrick Franz <deltaone@debian.org>  Sat, 26 Mar 2022 16:42:26 +0100

kdepim-runtime (4:21.12.3-2) experimental; urgency=medium

  [ Patrick Franz ]
  * Fix patches.

 -- Patrick Franz <deltaone@debian.org>  Sat, 26 Mar 2022 09:28:46 +0100

kdepim-runtime (4:21.12.3-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (21.12.3).
  * Update build-deps and deps with the info from cmake.
  * Add myself to Uploaders.
  * Refresh patches.

 -- Patrick Franz <deltaone@debian.org>  Thu, 24 Mar 2022 23:28:23 +0100

kdepim-runtime (4:21.08.1-1) unstable; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.08.1).
  * Bump Standards-Version to 4.6.0, no change required.

 -- Norbert Preining <norbert@preining.info>  Sat, 11 Sep 2021 07:21:04 +0900

kdepim-runtime (4:21.08.0-1) unstable; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.08.0).
  * Update patches.

 -- Norbert Preining <norbert@preining.info>  Tue, 17 Aug 2021 12:44:15 +0900

kdepim-runtime (4:21.04.3-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.04.3).

 -- Norbert Preining <norbert@preining.info>  Fri, 09 Jul 2021 10:34:30 +0900

kdepim-runtime (4:21.04.1-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.04.1).

 -- Norbert Preining <norbert@preining.info>  Fri, 14 May 2021 06:10:11 +0900

kdepim-runtime (4:21.04.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.04.0).
  * Borrow minimal upstream signing key from k3b.
  * Drop Kubuntu from maintainer name.
  * Removed George Kiagiadakis, Maximiliano Curia, Modestas Vainius from
    the uploaders, thanks for your work on the package!
  * Added myself to the uploaders.
  * Update patches.

 -- Norbert Preining <norbert@preining.info>  Thu, 13 May 2021 09:46:14 +0900

=== debian/control ===
Source: kdepim-runtime
Section: x11
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>,
           Sune Vuorela <debian@pusling.com>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.99.0~),
               gettext,
               libboost-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libgrantlee5-dev (>= 5.2~),
               libkf5akonadi-dev (>= 4:22.12.3~),
               libkf5akonadicalendar-dev (>= 4:22.12.3~),
               libkf5akonadicontact-dev (>= 4:22.12.3~),
               libkf5akonadimime-dev (>= 4:22.12.3~),
               libkf5akonadinotes-dev (>= 4:22.12.3~),
               libkf5calendarcore-dev (>= 5:5.99.0~),
               libkf5calendarutils-dev (>= 4:22.12.3~),
               libkf5codecs-dev (>= 5.99.0~),
               libkf5config-dev (>= 5.99.0~),
               libkf5configwidgets-dev (>= 5.99.0~),
               libkf5contacts-dev (>= 5:5.99.0~),
               libkf5dav-dev (>= 1:5.99.0~),
               libkf5doctools-dev (>= 5.99.0~),
               libkf5holidays-dev (>= 1:5.99.0~),
               libkf5identitymanagement-dev (>= 22.12.3~),
               libkf5imap-dev (>= 22.12.3~),
               libkf5itemmodels-dev (>= 5.99.0~),
               libkf5kcmutils-dev (>= 5.99.0~),
               libkf5kio-dev (>= 5.99.0~),
               libkf5ldap-dev (>= 22.12.3~),
               libkf5libkdepim-dev (>= 4:22.12.3~),
               libkf5mailtransport-dev (>= 22.12.3~),
               libkf5mbox-dev (>= 22.12.3~),
               libkf5mime-dev (>= 22.12.3~),
               libkf5notifications-dev (>= 5.99.0~),
               libkf5notifyconfig-dev (>= 5.99.0~),
               libkf5textwidgets-dev (>= 5.99.0~),
               libkf5windowsystem-dev (>= 5.99.0~),
               libkolabxml-dev (>= 1.1~),
               libkpimgapi-dev (>= 22.12.3~),
               libqca-qt5-2-dev (>= 2.3.0~),
               libqt5networkauth5-dev (>= 5.15.2~),
               libqt5texttospeech5-dev,
               libqt5xmlpatterns5-dev (>= 5.15.2~),
               libsasl2-dev,
               pkg-config,
               pkg-kde-tools (>= 0.12),
               qt5keychain-dev,
               qtbase5-dev (>= 5.15.2~),
               qtwebengine5-dev (>= 5.15.2~) [amd64 arm64 armhf i386 mips64el mipsel],
               shared-mime-info (>= 1.3~),
               xsltproc,
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/pim/kdepim-runtime
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kdepim-runtime
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kdepim-runtime.git
Rules-Requires-Root: no

Package: kdepim-runtime
Architecture: any
Depends: akonadi-server,
         kio-ldap,
         kmailtransport-akonadi,
         libsasl2-modules,
         libsasl2-modules-kdexoauth2 [amd64 arm64 armhf i386 mips64el mipsel],
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: libkf5libkdepim-data (<< 4:20.08~),
        libkf5libkdepim-plugins (<< 4:20.08~),
Replaces: libkf5libkdepim-data (<< 4:20.08~),
          libkf5libkdepim-plugins (<< 4:20.08~),
Description: runtime components for Akonadi KDE
 This package contains Akonadi agents written using KDE Development Platform
 libraries.
 Any package that uses Akonadi should probably pull this in as a dependency.
 The kres-bridges is also parts of this package.
 .
 This package is part of the kdepim-runtime module.
